import 'dart:convert';
import 'package:shared_preferences/shared_preferences.dart';

// 本地存储
class DemonSp {
  static late final SharedPreferences instance;

  static Future<SharedPreferences> init() async =>
      instance = await SharedPreferences.getInstance();

  static Future<bool> localSet(String key, dynamic jsonVal) async {
    String jsonString = jsonEncode(jsonVal);
    return await instance.setString(key, jsonString);
  }

  static dynamic localGet(String key) {
    String? jsonString = instance.getString(key);
    return jsonString == null ? null : jsonDecode(jsonString);
  }

  //bool 类型
  static Future<bool> setBool(String key, bool val) async {
    return await instance.setBool(key, val);
  }

  static bool getBool(String key, [bool? defValue]) {
    return instance.getBool(key) ?? defValue ?? true;
  }

  //字符串 类型
  static Future<bool> setString(String key, String val) async {
    return await instance.setString(key, val);
  }

  static String getString(String key, [String? defValue]) {
    return instance.getString(key) ?? defValue ?? "";
  }

  static Future<bool> remove(String key) async {
    return await instance.remove(key);
  }
}
